{***************************************************************************}
{*                                                                         *}
{* Unit:Errors                                                 Version 2.2 *}
{*                    Created by Rafal Zielinski.July 1997                 *}
{*                                                                         *}
{***************************************************************************}
{*                                                                         *}
{*  Features:                                                              *}
{*        -error codes for ALL units !                                     *}
{*        -show error string !                                             *}
{*        -show TP and BP error string !                                   *}
{*                                                                         *}
{***************************************************************************}
{$B-,F+,G+,I-,E-,P+,T-,V+,X+}

{$D-,L-,Q-,R-,S-,Y-}

Unit Errors;

Interface

Const erOK                              =0;
      erOutOfMemory                     =-1;
      erOutOfXMSMemory                  =-2;
      erOutOfEMSMemory                  =-3;
      erFileNotFound                    =-4;
      erFileNotOpen                     =-5;
      erInvalidDirectory                =-6;
      erReadError                       =-7;
      erWriteError                      =-8;
      erInvalidImageFormat              =-9;
      erInvalidAnimationFormat          =-10;
      erInvalidSpriteFormat             =-11;
      erInvalidSampleFormat             =-12;
      erInvalidImageSize                =-13;
      erInvalidFileFormat               =-14;
      erDataTooLarge                    =-15;
      erFileTooLarge                    =-16;
      erErrorInAlocatingMemory          =-17;
      erSoundBlasterCardNotFound        = -30;
      erSoundBlasterInitError           = -31;
      erSoundBlasterError               = -32;
      erErrorInPlaying                  = -33;

Function GetErrorStr(Er:integer):string;
Function GetTPErrorStr(Er:integer):string;

Implementation

Function GetErrorStr(Er:integer):string;begin
         Case Er of
           erOK                      :GetErrorStr:='OK';
           erOutOfMemory             :GetErrorStr:='Out of memory';
           erOutOfXMSMemory          :GetErrorStr:='Out of XMS memory';
           erOutOfEMSMemory          :GetErrorStr:='Out of EMS memory';
           erFileNotFound            :GetErrorStr:='File not found';
           erFileNotOpen             :GetErrorStr:='File not open';
           erInvalidDirectory        :GetErrorStr:='Invalid directory';
           erReadError               :GetErrorStr:='Read error';
           erWriteError              :GetErrorStr:='Write error';
           erInvalidImageFormat      :GetErrorStr:='Invalid image format';
           erInvalidAnimationFormat  :GetErrorStr:='Invalid animation format';
           erInvalidSpriteFormat     :GetErrorStr:='Invalid sprite format';
           erInvalidSampleFormat     :GetErrorStr:='Invalid sample format';
           erInvalidImageSize        :GetErrorStr:='Invalid image size';
           erInvalidFileFormat       :GetErrorStr:='Invalid file format';
           erDataTooLarge            :GetErrorStr:='Data too large';
           erFileTooLarge            :GetErrorStr:='File too large';
           erErrorInAlocatingMemory  :GetErrorStr:='Error in allocating memory';
           erSoundBlasterCardNotFound:GetErrorStr:='Sound Blaster card not found';
           erSoundBlasterInitError   :GetErrorStr:='Sound Blaster init error';
           erSoundBlasterError       :GetErrorStr:='Sound Blaster error';
           erErrorInPlaying          :GetErrorStr:='Error in playing';
         else
           GetErrorStr:='';
         end;
         end;

Function GetTPErrorStr(Er:integer):string;begin
         Case Er of
             1 :GetTPErrorStr:='Invalid function number';
             2 :GetTPErrorStr:='File not found';
             3 :GetTPErrorStr:='Path not found';
             4 :GetTPErrorStr:='Too many open files';
             5 :GetTPErrorStr:='File access denied';
             6 :GetTPErrorStr:='Invalid file handle';
            12 :GetTPErrorStr:='Invalid file access code';
            15 :GetTPErrorStr:='Invalid drive number';
            16 :GetTPErrorStr:='Cannot remove current directory';
            17 :GetTPErrorStr:='Cannot rename across drives';
            18 :GetTPErrorStr:='No more files';
           100 :GetTPErrorStr:='Disk read error';
           101 :GetTPErrorStr:='Disk write error';
           102 :GetTPErrorStr:='File not assigned';
           103 :GetTPErrorStr:='File not open';
           104 :GetTPErrorStr:='File not open for input';
           105 :GetTPErrorStr:='File not open for output';
           106 :GetTPErrorStr:='Invalid numeric format';
           150 :GetTPErrorStr:='Disk is write-protected';
           151 :GetTPErrorStr:='Bad drive request struct length';
           152 :GetTPErrorStr:='Drive not ready';
           154 :GetTPErrorStr:='CRC error in data';
           156 :GetTPErrorStr:='Disk seek error';
           157 :GetTPErrorStr:='Unknown media type';
           158 :GetTPErrorStr:='Sector Not Found';
           159 :GetTPErrorStr:='Printer out of paper';
           160 :GetTPErrorStr:='Device write fault';
           161 :GetTPErrorStr:='Device read fault';
           162 :GetTPErrorStr:='Hardware failure';
           200 :GetTPErrorStr:='Division by zero';
           201 :GetTPErrorStr:='Range check error';
           202 :GetTPErrorStr:='Stack overflow error';
           203 :GetTPErrorStr:='Heap overflow error';
           204 :GetTPErrorStr:='Invalid pointer operation';
           205 :GetTPErrorStr:='Floating point overflow';
           206 :GetTPErrorStr:='Floating point underflow';
           207 :GetTPErrorStr:='Invalid floating point operation';
           208 :GetTPErrorStr:='Overlay manager not installed';
           209 :GetTPErrorStr:='Overlay file read error';
           210 :GetTPErrorStr:='Object not initialized';
           211 :GetTPErrorStr:='Call to abstract method;';
           212 :GetTPErrorStr:='Stream registration error';
           213 :GetTPErrorStr:='Collection index out of range';
           214 :GetTPErrorStr:='Collection overflow error';
           215 :GetTPErrorStr:='Arithmetic overflow error';
           216 :GetTPErrorStr:='General Protection fault';
         else
           GetTPErrorStr:=''
         end
         end;

end.
