{***************************************************************************}
{*                                                                         *}
{* Unit:Image                                                  Version 3.2 *}
{*                    Created by Rafal Zielinski.October 1997              *}
{*                                                                         *}
{***************************************************************************}
{*                                                                         *}
{*  Features:                                                              *}
{*        -load and store many image-formats (PCX,BMP,GIF,WPG,CEL...)      *}
{*                                                                         *}
{***************************************************************************}
{$B-,F+,G+,I-,E-,P+,T-,V+,X+}

{$D-,L-,Q-,R-,S-,Y-}

Unit Image;

Interface

Uses VGAPal,Errors;

Const GIFSlownik                           =4096;

Type TImageAttr = record
            FileName: string;
            Width,Height: word;
            Colors: word;
     end;

     PImageBuffer=^TImageBuffer;
     TImageBuffer=array[0..65534] of byte;

     PImage = ^TImage;
     TImage = object
            ImageAttribute:TImageAttr;
            ImagePalette:TVGAPalette;
            Constructor Init;
            Function LoadPalette(Name:string):shortint;
            Function SavePalette(Name:string):shortint;
            Function GetAttr(Name:string):shortint;virtual;
            Function Load(Name:string):shortint;virtual;
            Function Save(Width,Height:word;Name:string):shortint;virtual;
            Procedure InitImage;virtual;
            Procedure OutData(Line:array of byte;Width,LineCount:word);virtual;
            Procedure InData(Var Line:array of byte;Width,LineCount:word);virtual;
            Destructor Done;
     end;

     TCELHead = record
            Par1,Par2: byte;
            Width: word;
            Height: word;
            Data: array[1..26] of byte;
            Palette: array[0..767] of byte;
     end;

     PCEL = ^TCEL;
     TCEL = object(TImage)
            Constructor Init;
              Function GetAttr(Name:string):shortint;virtual;
              Function Load(Name:string):shortint;virtual;
              Function Save(Width,Height:word;Name:string):shortint;virtual;
              Procedure InitImage;virtual;
              Procedure OutData(Line:array of byte;Width,LineCount:word);virtual;
              Procedure InData(Var Line:array of byte;Width,LineCount:word);virtual;
            Destructor Done;
            Private
              CELHead: TCELHead;
     end;

     TPCXHead = record                                 {<<<-PCX Head}
            flag: byte;
            Version: byte;
            EnCoding: byte;
            BitsPerPixel: byte;
            Xmin,Ymin: integer;
            Xmax,Ymax: integer;
            Hdpi,Vdpi: integer;
            ColorMap: array[1..48] of byte;
            Reserved: byte;
            Nplanes: byte;
            BytesPerLine: integer;
            PaletteInfo: integer;
            HscreenSize: integer;
            VscreenSize: integer;
            Filler: array[1..54] of byte;
     end;

     TPCXExtPalette = array[0..767] of byte;

     PPCX = ^TPCX;
     TPCX = object(TImage)
            Constructor Init;
              Function GetAttr(Name:string):shortint;virtual;
              Function Load(Name:string):shortint;virtual;
              Function Save(Width,Height:word;Name:string):shortint;virtual;
              Procedure InitImage;virtual;
              Procedure OutData(Line:array of byte;Width,LineCount:word);virtual;
              Procedure InData(Var Line:array of byte;Width,LineCount:word);virtual;
            Destructor Done;
            Private
              PCXHead: TPCXHead;
              PCXExtPalette: TPCXExtPalette;
     end;

     TBMPHead = record
            bfType: array[1..2] of char;
            bfSize: longint;
            Reserved1: word;
            Reserved2: word;
            OffBits: longint;
            biSize: longint;
            Width: longint;
            Height: longint;
            Planes: word;
            BitCount: word;
            Compression: longint;
            SizeImage: longint;
            XPelsPerMeter: longint;
            YPelsPerMeter: longint;
            ClrUsed: longint;
            ClrImportant: longint;
     end;

     TBMPPalette = array[0..1023] of byte;

     PBMP = ^TBMP;
     TBMP = object(TImage)
            Constructor Init;
              Function GetAttr(Name:string):shortint;virtual;
              Function Load(Name:string):shortint;virtual;
              Function Save(Width,Height:word;Name:string):shortint;virtual;
              Procedure InitImage;virtual;
              Procedure OutData(Line:array of byte;Width,LineCount:word);virtual;
              Procedure InData(Var Line:array of byte;Width,LineCount:word);virtual;
            Destructor Done;
            Private
              BMPHead: TBMPHead;
              BMPPalette: TBMPPalette;
     end;

     RodzajMapyKolorow = (Globalny,Lokalny);

     PrologGIF = record
            Naglowek: array[1..6] of char;
            SzerokoscEkranu: word;
            WysokoscEkranu: word;
            PoleBitowe: Byte;
            KolorTla: byte;
            PixelAspectRatio: byte;
     end;

     TablicaKolorow = array[Globalny..Lokalny,0..255] of record
            C,Z,N: byte;
     end;

     OpisObrazu = record
            OdKolumny: word;
            OdLini: word;
            SzerokoscObrazu: word;
            WysokoscObrazu: word;
            PoleBitowe: byte;
     end;

     TSlownik = array[0..GIFSlownik] of record
            Poziom: word;
            Dana: byte;
     end;

     TStos = array[0..1024] of byte;

     PGIF = ^TGIF;
     TGIF = object(TImage)
            Constructor Init;
              Function GetAttr(Name:string):shortint;virtual;
              Function Load(Name:string):shortint;virtual;
              Procedure InitImage;virtual;
              Procedure OutData(Line:array of byte;Width,LineCount:word);virtual;
            Destructor Done;
            Private
              Prolog: PrologGIF;
              OpisObr: OpisObrazu;
              MapaKolorow: RodzajMapyKolorow;
              BitowNaKolor: byte;
              LiczbaKolorow: array[Globalny..Lokalny] of word;
              JestMapa: array[Globalny..Lokalny] of boolean;
              ScrLine:array[0..2048] of byte;
              Przeplatany,
              Koniec: boolean;
              ZostaloBitow: ShortInt;
              LiczbaBitow,
              OdIluBitow: byte;
              IndeksBufora,
              IndeksDanych,
              IleBajtow: word;
              Poziom,
              OdPoziomu,
              PoziomStosu: word;
              PoprzedniKOD,
              AktualnyKOD: word;
              KoniecDanych,
              Nowy: word;
              Tymczasowy,
              Zatrzask: word;
              Linie,MaxX,MaxY,
              XEkr,YEkr: word;
              Etykieta: byte;
              St,Tr: integer;
              NaEkran: byte;
              Kolory: TablicaKolorow;
              Slownik: ^TSlownik;
              Stos: ^TStos;
              f: file;

              Procedure NaEkran1(Kolor:byte);
              Procedure NaEkran2(Kolor:byte);
              Procedure Na_Ekran(Kolor:byte);
              Function WezBajt:byte;
              Procedure WezBlok(Var V;Ile:word);
              Function WezBajtDanych:word;
              Function WezKod(IleBitow:byte):word;
              Procedure Inicjuj;
              Procedure Rozpakuj;
              Procedure OminRozszerzenie;
              Procedure WezProlog;
              Procedure WezOpisObrazu;
              Procedure WezKolory;
              Procedure DefiniujKolory;
     end;

     TTIFHead = record
            IFFType: array[1..4] of byte;
            Reserved: array[1..4] of byte;
            Name: array[1..21] of char;
     end;

     TTIFHead1 = record
            Fill: array[1..22] of byte;
            Width: word;
            Fill1: array[1..10] of byte;
            Height: word;
            Fill2: array[1..10] of byte;
            BitsPerPixel:byte;
            Fill3: array[1..12] of byte;
            Compression: byte;
            Fill4: array[1..78] of byte;
     end;

     TTIFRGBPalette = array[0..2,0..255] of word;

     PTIF = ^TTIF;
     TTIF = object(TImage)
            Constructor Init;
              Function GetAttr(Name:string):shortint;virtual;
              Function Load(Name:string):shortint;virtual;
              Procedure InitImage;virtual;
              Procedure OutData(Line:array of byte;Width,LineCount:word);virtual;
            Destructor Done;
            Private
              TIFHead:TTIFHead;
              TIFHead1:TTIFHead1;
              TIFPalette:TTIFRGBPalette;
     end;

     TWPGHead = record
         Start: byte;
         WPGType: array[1..3] of char;
         Fill: array[5..25] of byte;
         Colors: byte;                   {<<<--$ff-256,$34-16}
         Fill1: array[1..6] of byte;
         end;

     TWPGHead1 = record
         Fill: array[1..6] of byte;
         Width: word;
         Height: word;
         Fill1: array[13..18] of byte;
         end;

     TWPGPalette= array[0..767] of byte;

     PWPG=^TWPG;
     TWPG=object(TImage)
            Constructor Init;
              Function GetAttr(Name:string):shortint;virtual;
              Function Load(Name:string):shortint;virtual;
              Procedure InitImage;virtual;
              Procedure OutData(Line:array of byte;Width,LineCount:word);virtual;
            Destructor Done;
            Private
              WPGHead:TWPGHead;
              WPGHead1:TWPGHead1;
              WPGPalette:TWPGPalette;
     end;

     TTGAHead=record
            TGAType: array[1..4] of byte;
            Fill: array[5..12] of byte;
            Width: word;
            Height: word;
            Bits: byte;
            Fill1: byte;
     end;

     TTGAPalette=array[0..767] of byte;

     PTGA=^TTGA;
     TTGA=object(TImage)
            Constructor Init;
              Function GetAttr(Name:string):shortint;virtual;
              Function Load(Name:string):shortint;virtual;
              Function Save(Width,Height:word;Name:string):shortint;virtual;
              Procedure InitImage;virtual;
              Procedure OutData(Line:array of byte;Width,LineCount:word);virtual;
              Procedure InData(Var Line:array of byte;Width,LineCount:word);virtual;
            Destructor Done;
            Private
              TGAHead:TTGAHead;
              TGAPalette:TTGAPalette;
     end;

     PICO=^TICO;
     TICO=object(TImage)
            Constructor Init;
              Function Load(Name:string):shortint;virtual;
              Procedure OutData(Line:array of byte;Width,LineCount:word);virtual;
            Destructor Done;
     end;

     { TLoadGIF }

     PLoadGIF = ^TLoadGIF;
     TLoadGIF = object(TGIF)
            OutBuffer : PImageBuffer;
            Constructor Init(AOutBuffer:pointer);
            Procedure InitImage;virtual;
            Procedure OutData(Line:array of byte;Width,LineCount:word);virtual;
     end;

     { TLoadCEL }

     PLoadCEL = ^TLoadCEL;
     TLoadCEL = object(TCEL)
            OutBuffer : PImageBuffer;
            Constructor Init(AOutBuffer:pointer);
            Procedure InitImage;virtual;
            Procedure OutData(Line:array of byte;Width,LineCount:word);virtual;
     end;

     { TLoadPCX }

     PLoadPCX = ^TLoadPCX;
     TLoadPCX = object(TPCX)
            OutBuffer : PImageBuffer;
            Constructor Init(AOutBuffer:pointer);
            Procedure InitImage;virtual;
            Procedure OutData(Line:array of byte;Width,LineCount:word);virtual;
     end;

Var  ImageBuffer: PImageBuffer;

Function InitImages:shortint;
Procedure DoneImages;

Function FastLoadPCX320x200(Name:string;Var Buf;Var Pal:TVGAPalette;Var W,H:word):shortint;

Implementation

Function InitImages;begin
         if (MaxAvail<SizeOF(TImageBuffer)) then begin
            InitImages:=erOutOfMemory;
            Exit;
         end;
         New(ImageBuffer);
         InitImages:=erOK;
         end;

Procedure DoneImages;begin
          if ImageBuffer<>NIL then begin
             Dispose(ImageBuffer);
             ImageBuffer:=NIL;
          end;
          end;

{ TImage }

Constructor TImage.Init;begin
            ImageAttribute.FileName:='';
            ImageAttribute.Width:=0;
            ImageAttribute.Height:=0;
            ImageAttribute.Colors:=0;
            end;

Function TImage.LoadPalette(Name:string):shortint;
Var f:file;
begin
         FileMode:=0;
         Assign(f,Name);
         {$I-}
         Reset(f,1);
         {$I+}
         If IOResult<>0 then begin
            LoadPalette:=erFileNotFound;
            Exit;
         end;
         BlockRead(f,ImagePalette,SizeOf(ImagePalette));
         Close(f);
         LoadPalette:=erOK;
         end;

Function TImage.SavePalette(Name:string):shortint;
Var f:file;
begin
         Assign(f,Name);
         {$I-}
         Rewrite(f,1);
         {$I+}
         If IOResult<>0 then begin
            SavePalette:=erWriteError;
            Exit;
         end;
         BlockWrite(f,ImagePalette,SizeOf(ImagePalette));
         Close(f);
         SavePalette:=erOK;
         end;

Function TImage.GetAttr(Name:string):shortint;begin
         end;

Function TImage.Load(Name:string):shortint;begin
         end;

Function TImage.Save(Width,Height:word;Name:string):shortint;begin
         end;

Procedure TImage.InitImage;begin
          end;

Procedure TImage.OutData(Line:array of byte;Width,LineCount:word);begin
          end;

Procedure TImage.InData(Var Line:array of byte;Width,LineCount:word);begin
          end;

Destructor TImage.Done;begin
           end;

{ TCEL }

Constructor TCEL.Init;begin
            FillChar(CELHead,SizeOF(CELHead),0);
            end;

Destructor TCEL.Done;begin
           FillChar(CELHead,SizeOF(CELHead),0);
           end;

Function TCEL.GetAttr(Name:string):shortint;
Var f:file;
begin
         FileMode:=0;
         Assign(f,Name);
         {$I-}
         Reset(f,1);
         {$I+}
         If IOResult<>0 then begin
            GetAttr:=erFileNotFound;
            Exit;
         end;
         {$I-}
         BlockRead(f,CELHead,SizeOf(TCELHead));
         {$I+}
         If IOResult<>0 then begin
            GetAttr:=erReadError;
            Exit;
         end;
         Close(f);

         {*** Init ImageAttr ***}

         ImageAttribute.FileName:=Name;
         ImageAttribute.Width:=CELHead.Width;
         ImageAttribute.Height:=CELHead.Height;
         ImageAttribute.Colors:=256;
         Move(CELHead.Palette,ImagePalette,768);

         GetAttr:=erOK;
         end;

Function TCEL.Load(Name:string):shortint;
Var ScrLine:array[0..2048] of byte;
    x1,y1:word;
    f:file;
begin
         FileMode:=0;
         Assign(f,Name);
         {$I-}
         Reset(f,1);
         {$I+}
         If IOResult<>0 then begin
            Load:=erFileNotFound;
            Exit;
         end;
         {$I-}
         BlockRead(f,CELHead,SizeOf(TCELHead));
         BlockRead(f,ImageBuffer^,CELHead.Width*CElHead.Height);
         {$I+}
         If IOResult<>0 then begin
            Load:=erReadError;
            Close(f);
            Exit;
         end;
         Close(f);

         {*** Init ImageAttr ***}

         ImageAttribute.FileName:=Name;
         ImageAttribute.Width:=CELHead.Width;
         ImageAttribute.Height:=CELHead.Height;
         ImageAttribute.Colors:=256;
         Move(CELHead.Palette,ImagePalette,768);

         {*** Show CEL ***}

         InitImage;

         For y1:=0 to (CELHead.Height-1) do begin
             Move(ImageBuffer^[(y1*CELHead.Width)],ScrLine,CELHead.Width);
             OutData(ScrLine,CELHead.Width,y1);
         end;
         Load:=erOK;
         end;

Function TCEL.Save(Width,Height:word;Name:string):shortint;
Var ScrLine:array[0..2048] of byte;
    BufferCount,z:word;
    Pal:TVGAPalette;
    y:word;
    f:file;
begin
         Assign(f,Name);
         {$I-}
         Rewrite(f,1);
         {$I+}
         if IOResult<>0 then begin
            Save:=erWriteError;
            Close(f);
            Exit;
         end;

         {*** Check ***}

         if (Width>320) OR (Height>200) then begin
            Save:=erInvalidImageSize;
            Close(f);
            Exit;
         end;

         {*** Init CELHead ***}

         CELHead.Width:=Width;
         CELHead.Height:=Height;
         CELHead.Par1:=$19;
         CELHead.Par2:=$91;
         FillChar(CELHead.Data,SizeOF(CELHead.Data),0);
         CELHead.Data[5]:=$08;
         CELHead.Data[8]:=$fa;
         GetAllPalette(Pal);
         Move(Pal,CELHead.Palette,768);

         {*** Save CEL ***}

         BufferCount:=0;
         For Y:=0 to (Height-1) do begin
             InData(ScrLine,Width,Y);
             Move(ScrLine,ImageBuffer^[BufferCount],Width);
             Inc(BufferCount,Width);
         end;
         {$I-}
         BlockWrite(f,CELHead,SizeOF(CELHead));
         BlockWrite(f,ImageBuffer^,BufferCount);
         {$I+}
         if IOResult<>0 then begin
            Save:=erWriteError;
            Close(f);
            Exit;
         end;
         Close(f);
         Save:=erOK;
         end;

Procedure TCEL.InitImage;begin
          SetAllPalette(ImagePalette);
          end;

Procedure TCEL.OutData(Line:array of byte;Width,LineCount:word);begin
          end;

Procedure TCEL.InData(Var Line:array of byte;Width,LineCount:word);begin
          end;

{ TPCX }

Constructor TPCX.Init;begin
            FillChar(PCXHead,SizeOF(PCXHead),0);
            FillChar(PCXExtPalette,SizeOF(PCXExtPalette),0);
            end;

Destructor TPCX.Done;begin
           FillChar(PCXHead,SizeOF(PCXHead),0);
           FillChar(PCXExtPalette,SizeOF(PCXExtPalette),0);
           end;

Function TPCX.GetAttr(Name:string):shortint;
Var z:word;
    f:file;
begin
         FileMode:=0;
         Assign(f,Name);
         {$I-}
         Reset(f,1);
         {$I+}
         if IOResult<>0 then begin
            GetAttr:=erFileNotFound;
            Close(f);
            Exit;
         end;
         {$I-}
         BlockRead(f,PCXHead,SizeOf(PCXHead));

         {*** Check if 256 colors ***}

         if (PCXHead.BitsPerPixel=8) then begin
            Seek(f,FileSize(f)-768);
            BlockRead(f,PCXExtPalette,SizeOF(PCXExtPalette));
            For z:=0 to 767 do
                PCXExtPalette[z]:=PCXExtPalette[z] SHR 2;
            Move(PCXExtPalette,ImagePalette,768);
            ImageAttribute.Colors:=256;
         end else begin
            Move(PCXHead.ColorMap,ImagePalette,SizeOF(PCXHead.ColorMap));
            ImageAttribute.Colors:=1 SHL PCXHead.BitsPerPixel;
         end;

         {$I+}
         if IOResult<>0 then begin
            GetAttr:=erReadError;
            Close(f);
            Exit;
         end;
         Close(f);

         {*** Init ImageAttr ***}

         ImageAttribute.FileName:=Name;
         ImageAttribute.Width:=PCXHead.Xmax+1;
         ImageAttribute.Height:=PCXHead.Ymax+1;

         GetAttr:=erOK;
         end;

Function TPCX.Load(Name:string):shortint;
Var ScrLine:array[0..2048] of byte;
    CurX,CurY,z:word;
    PCXByte,x,Count:byte;
    Size,ReadOffset,ReadBytes:longint;
    f:file;

    I:pointer;

Function GetByte(Var B:byte):shortint;
Var R:word;
begin
         if (ReadOffset>2048-1) then begin
            {$I-}
            BlockRead(f,I^,2048,R);
            {$I+}
            if IOResult<>0 then begin
               GetByte:=erReadError;
               Exit;
            end;
            ReadOffset:=0;
         end;
         B:=Mem[Seg(I^):Ofs(I^)+ReadOffset];
         Inc(ReadOffset);
         Inc(ReadBytes);
         GetByte:=erOK;
         end;
begin
         if (MaxAvail<2048) then begin
            Load:=erOutOfMemory;
            Exit;
         end;
         FileMode:=0;
         Assign(f,Name);
         {$I-}
         Reset(f,1);
         {$I+}
         if IOResult<>0 then begin
            Load:=erFileNotFound;
            Close(f);
            Exit;
         end;

         if (GetAttr(Name)<>erOK) then begin
            Load:=GetAttr(Name);
            Close(f);
            Exit;
         end;

         InitImage;

         GetMem(I,2048);

         if (PCXHead.BitsPerPixel=8) then
            Size:=FileSize(f)-128-SizeOF(TPCXExtPalette)-1
         else
            Size:=FileSize(f)-128;

         {*** Show PCX ***}

         Assign(f,Name);
         Reset(f,1);
         Seek(f,128);

         ReadBytes:=0;
         ReadOffset:=99999;

         CurY:=0;
         Repeat
           CurX:=0;
           Repeat
             if (GetByte(PCXByte)<>erOK) then begin
                Load:=erReadError;
                FreeMem(I,2048);
                Close(f);
                Exit;
             end;
             if (PCXByte and $c0)=$c0 then begin
                Count:=PCXByte and $3f;
                if (GetByte(PCXByte)<>erOK) then begin
                   Load:=erReadError;
                   FreeMem(I,2048);
                   Close(f);
                   Exit;
                end;
                for x:=1 to Count do begin
                    ScrLine[Curx]:=PCXByte;
                    Inc(CurX);
                end;
             end else begin
                ScrLine[Curx]:=PCXByte;
                Inc(CurX);
             end;
           Until (CurX>=PCXHead.BytesPerLine*PCXHead.NPlanes);
           OutData(ScrLine,PCXHead.BytesPerLine*PCXHead.NPlanes,CurY);
           Inc(CurY);
         Until (CurY>PCXHead.YMax);
         Close(f);
         FreeMem(I,2048);
         Load:=erOK;
         end;

Function TPCX.Save(Width,Height:word;Name:string):shortint;
Var ScrLine:array[0..2048] of byte;
    CodeLine:array[0..2048] of byte;
    CurX,CurY,x,z,Count,HowMany:integer;
    k,k1,PcxByte:byte;
    Pal:TVGAPalette;
    f:file;
begin
          Assign(f,Name);
          {$I-}
          Rewrite(f,1);
          {$I+}
          if IOResult<>0 then begin
             Save:=erWriteError;
             Close(f);
             Exit;
          end;

          {*** Init PCXHead ***}

          PCXHead.Flag:=10;
          PCXHead.Version:=5;
          PCXHead.Encoding:=1;
          PCXHead.BitsPerPixel:=8; {<<<-256 colors}
          PCXHead.Xmin:=0;
          PCXHead.Ymin:=0;
          PCXHead.Xmax:=Width-1;
          PCXHead.Ymax:=Height-1;
          PCXHead.Hdpi:=0;
          PCXHead.Vdpi:=0;
          FillChar(PCXHead.ColorMap,SizeOF(PCXHead.ColorMap),0);
          PCXHead.Reserved:=0;
          PCXHead.Nplanes:=1;
          PCXHead.BytesPerLine:=Width;
          PCXHead.PaletteInfo:=1;  {<<<-Colour palette}
          PCXHead.HscreenSize:=0;
          PCXHead.VscreenSize:=0;
          FillChar(PCXHead.Filler,SizeOF(PCXHead.Filler),0);

          {$I-}
          BlockWrite(f,PCXHead,SizeOF(PCXHead));
          {$I+}
          if IOResult<>0 then begin
             Save:=erWriteError;
             Close(f);
             Exit;
          end;

          {*** Save PCX ***}

          CurY:=0;
          Repeat
            CurX:=0;
            Count:=0;
            FillChar(CodeLine,SizeOf(CodeLine),0);
            InData(ScrLine,Width,CurY);
            Repeat
              k:=ScrLine[CurX];
              HowMany:=0;
              For x:=(CurX+1) to Width do begin
                  if (ScrLine[x]<>k) OR (HowMany=63) then Break;
                  Inc(HowMany);
              end;
              if (HowMany=0) then
                     if (k<$c0) then begin
                        PCXByte:=k;
                        Inc(CurX);
                     end else begin
                         CodeLine[Count]:=(1 OR $c0);
                         Inc(Count);
                         PCXByte:=k;
                         Inc(CurX);
                     end
              else begin
                  CodeLine[Count]:=(HowMany OR $c0);
                  Inc(Count);
                  PCXByte:=k;
                  Inc(CurX,HowMany);
              end;
              CodeLine[Count]:=PCXByte;
              Inc(Count);
            Until (CurX>=Width);
            {$I-}
            BlockWrite(f,CodeLine,Count);
            {$I+}
            if IOResult<>0 then begin
               Save:=erWriteError;
               Close(f);
               Exit;
            end;
            Inc(CurY);
          Until (CurY>=Height);

          {*** Save extended palette code ***}

          PCXByte:=$0C;
          {$I-}
          BlockWrite(f,PCXByte,1);
          {$I+}
          if IOResult<>0 then begin
             Save:=erWriteError;
             Close(f);
             Exit;
          end;

          {*** Get and save extended palette ***}

          GetAllPalette(Pal);
          Move(Pal,PCXExtPalette,768);
          For z:=0 to 767 do
              PCXExtPalette[z]:=PCXExtPalette[z] SHL 2;
          {I-}
          BlockWrite(f,PCXExtPalette,SizeOF(PCXExtPalette));
          {$I+}
          if IOResult<>0 then begin
             Save:=erWriteError;
             Close(f);
             Exit;
          end;
          Close(f);
          Save:=erOK;
          end;

Procedure TPCX.InitImage;begin
          SetAllPalette(ImagePalette);
          end;

Procedure TPCX.OutData(Line:array of byte;Width,LineCount:word);begin
          end;

Procedure TPCX.InData(Var Line:array of byte;Width,LineCount:word);begin
          end;

{ TBMP }

Constructor TBMP.Init;begin
            FillChar(BMPHead,SizeOF(BMPHead),0);
            FillChar(BMPPalette,SizeOF(BMPPalette),0);
            end;

Destructor TBMP.Done;begin
           FillChar(BMPHead,SizeOF(BMPHead),0);
           FillChar(BMPPalette,SizeOF(BMPPalette),0);
           end;

Function TBMP.GetAttr(Name:string):shortint;
Var f:file;
begin
          FileMode:=0;
          Assign(f,Name);
          {$I-}
          Reset(f,1);
          {$I+}
          if IOResult<>0 then begin
             GetAttr:=erFileNotFound;
             Exit;
          end;
          {$I-}
          BlockRead(f,BMPHead,SizeOF(BMPHead));
          {$I+}
          if IOResult<>0 then begin
             GetAttr:=erReadError;
             Exit;
          end;
          Close(f);
          if BMPHead.bfType<>'BM' then begin
             GetAttr:=erInvalidImageFormat;
             Close(f);
             Exit;
          end;

          {*** Init ImageAttr ***}

          ImageAttribute.FileName:=Name;
          ImageAttribute.Width:=BMPHead.Width;
          ImageAttribute.Height:=BMPHead.Height;
          ImageAttribute.Colors:=1 SHL BMPHead.BitCount;

          GetAttr:=erOK;
          end;

Function TBMP.Load(Name:string):shortint;
Var ScrLine:array[0..2048] of byte;
    z,y:word;
    R,R1,G,B:byte;
    f:file;
begin
          FileMode:=0;
          Assign(f,Name);
          {$I-}
          Reset(f,1);
          {$I+}
          if IOResult<>0 then begin
             Load:=erFileNotFound;
             Exit;
          end;
          if GetAttr(Name)<>erOK then begin
             Load:=erReadError;
             Close(f);
             Exit;
          end;
          if (BMPHead.BitCount<>8) OR (BMPHead.Compression<>0) then begin
             Load:=erInvalidImageFormat;
             Close(f);
             Exit;
          end;

          {*** Load and convert palette ***}

          {$I-}
          Seek(f,54);
          BlockRead(f,BMPPalette,SizeOF(BMPPalette));
          {$I+}
          if IOResult<>0 then begin
             Load:=erReadError;
             Close(f);
             Exit;
          end;
          For z:=0 to 255 do begin
              R:=BMPPalette[(z*4)];
              G:=BMPPalette[(z*4)+1];
              B:=BMPPalette[(z*4)+2];
              R1:=R;
              R:=B;
              B:=R1;
              R:=R SHR 2;
              G:=G SHR 2;
              B:=B SHR 2;
              ImagePalette[z,0]:=R;
              ImagePalette[z,1]:=G;
              ImagePalette[z,2]:=B;
          end;

          InitImage;

          {*** Show BMP ***}

          For y:=BMPHead.Height-1 downto 0 do begin
              {$I-}
              BlockRead(f,ScrLine,BMPHead.Width);
              {$I+}
              if IOResult<>0 then begin
                 Load:=erReadError;
                 Close(f);
                 Exit;
              end;
              OutData(ScrLine,BMPHead.Width,y);
          end;
          Close(f);
          Load:=erOK;
          end;

Function TBMP.Save(Width,Height:word;Name:string):shortint;
Var ScrLine:array[0..2048] of byte;
    R,R1,G,B,z:byte;
    y:word;
    Pal:TVGAPalette;
    f:file;
begin
          Assign(f,Name);
          {$I-}
          Rewrite(f,1);
          {$I+}
          if IOResult<>0 then begin
             Save:=erWriteError;
             Close(f);
             Exit;
          end;

          {*** Init BMPHead ***}

          BMPHead.bfType:='BM';
          BMPHead.bfSize:=(Width*Height)+SizeOF(BMPHead)+SizeOF(BMPPalette);
          BMPHead.Reserved1:=0;
          BMPHead.Reserved2:=0;
          BMPHead.OffBits:=1078;
          BMPHead.biSize:=40;
          BMPHead.Width:=Width;
          BMPHead.Height:=Height;
          BMPHead.Planes:=1;
          BMPHead.BitCount:=8;
          BMPHead.Compression:=0;  {<<<-no compression}
          BMPHead.SizeImage:=Width*Height;
          BMPHead.XPelsPerMeter:=0;
          BMPHead.YPelsPerMeter:=0;
          BMPHead.ClrUsed:=0;
          BMPHead.ClrImportant:=0;

          {*** Save BMPHead ***}

          {$I-}
          BlockWrite(f,BMPHead,SizeOF(BMPHead));
          {$I+}
          if IOResult<>0 then begin
             Save:=erWriteError;
             Close(f);
             Exit;
          end;

          {*** Convert and save palette ***}

          GetAllPalette(Pal);
          FillChar(BMPPalette,SizeOF(BMPPalette),0);
          For z:=0 to 255 do begin
              R:=Pal[z,0] SHL 2;
              G:=Pal[z,1] SHL 2;
              B:=Pal[z,2] SHL 2;
              R1:=R;
              R:=B;
              B:=R1;
              BMPPalette[(z*4)]:=R;
              BMPPalette[(z*4)+1]:=G;
              BMPPalette[(z*4)+2]:=B;
          end;
          {$I-}
          BlockWrite(f,BMPPalette,SizeOF(BMPPalette));
          {$I+}
          if IOResult<>0 then begin
             Save:=erWriteError;
             Close(f);
             Exit;
          end;

          {*** Save BMP ***}

          For y:=(BMPHead.Height-1) downto 0 do begin
              InData(ScrLine,Width,y);
              {$I-}
              BlockWrite(f,ScrLine,Width);
              {$I+}
              if IOResult<>0 then begin
                 Save:=erWriteError;
                 Close(f);
                 Exit;
              end;
          end;
          Close(f);
          Save:=erOK;
          end;

Procedure TBMP.InitImage;begin
          SetAllPalette(ImagePalette);
          end;

Procedure TBMP.OutData(Line:array of byte;Width,LineCount:word);begin
          end;

Procedure TBMP.InData(Var Line:array of byte;Width,LineCount:word);begin
          end;

{ TGIF }

Constructor TGIF.Init;begin
            end;

Destructor TGIF.Done;begin
           end;

Procedure TGIF.NaEkran1;begin
          if (XEkr>MaxX) then begin
             OutData(ScrLine,MaxX+1,YEkr);
             XEkr:=0;
             Inc(YEkr);
             if (YEkr>MaxY) then
                YEkr:=0;
          end;
          ScrLine[XEkr]:=Kolor;
          Inc(XEkr);
          end;

Procedure TGIF.NaEkran2;
Const YInc:array[1..5] of byte=(8,8,4,2,1);
      YLin:array[1..5] of byte=(0,4,2,1,0);
begin
          if (XEkr>MaxX) then begin
             XEkr:=0;
             OutData(ScrLine,MaxX+1,YEkr);
             Inc(YEkr,YInc[Linie]);
             if (YEkr>MaxY) then begin
                Inc(Linie);
                YEkr:=YLin[Linie];
             end;
          end;
          ScrLine[XEkr]:=Kolor;
          Inc(XEkr);
          end;

Procedure TGIF.Na_Ekran;begin
          Case NaEkran of
               1:NaEkran1(Kolor);
               2:NaEkran2(Kolor);
          end;
          end;

Function TGIF.WezBajt:byte;begin
          if (IndeksBufora>=IleBajtow) then begin
             BlockRead(f,ImageBuffer^,SizeOF(TImageBuffer),IleBajtow);
             if (IleBajtow=0) then begin
                WezBajt:=0;
                Exit;
             end;
             IndeksBufora:=0;
          end;
          WezBajt:=ImageBuffer^[IndeksBufora];
          Inc(IndeksBufora);
          end;

Procedure TGIF.WezBlok;
Var w:word;
begin
          if Ile>IleBajtow then w:=IleBajtow else w:=Ile;
          Move(ImageBuffer^[IndeksBufora],V,W);
          Dec(Ile,w);
          Inc(IndeksBufora,w);
          if (IndeksBufora>=IleBajtow) then begin
             BlockRead(f,ImageBuffer^,SizeOF(TImageBuffer),IleBajtow);
             if (IleBajtow=0) then Exit;
             IndeksBufora:=0;
          end;
          Move(ImageBuffer^[IndeksBufora],V,Ile);
          Inc(IndeksBufora,Ile);
          end;

Function TGIF.WezBajtDanych:word;begin
          if (IndeksDanych=0) then IndeksDanych:=WezBajt;
          if (IndeksDanych>=1) then begin
             WezBajtDanych:=WezBajt;
             Dec(IndeksDanych);
          end else WezBajtDanych:=GIFSlownik+1;
          end;

Function TGIF.WezKod;
Const Maska:array[1..8] of byte=($01,$03,$07,$0f,$1f,$3f,$7f,$ff);
Var TrzebaBitow,Ile:byte;
    Kod:word;
begin
          TrzebaBitow:=IleBitow;
          Kod:=0;
          While (TrzebaBitow>0) do begin
                if (ZostaloBitow<=0) then begin
                   Zatrzask:=WezBajtDanych;
                   if Zatrzask>GIFSlownik then begin
                      WezKod:=KoniecDanych;
                      Exit;
                   end;
                   ZostaloBitow:=8;
                end;
                if (TrzebaBitow>=ZostaloBitow) then Ile:=ZostaloBitow
                                               else Ile:=TrzebaBitow;
                Kod:=Kod OR ((Zatrzask AND Maska[Ile]) SHL (IleBitow-TrzebaBitow));
                Zatrzask:=Zatrzask SHR Ile;
                Dec(TrzebaBitow,Ile);
                Dec(ZostaloBitow,Ile);
          end;
          WezKod:=Kod;
          end;

Procedure TGIF.Inicjuj;begin
          LiczbaBitow:=OdIluBitow+1;
          Poziom:=1 SHL OdIluBitow;
          Nowy:=Poziom;
          KoniecDanych:=Poziom+1;
          Inc(Poziom,2);
          OdPoziomu:=Poziom;
          end;

Procedure TGIF.Rozpakuj;
Var c:char;
begin
          IndeksDanych:=0;
          PoziomStosu:=0;
          ZostaloBitow:=0;
          OdIluBitow:=WezBajt;
          if OdIluBitow=0 then Exit;
          FillChar(Slownik^,SizeOF(TSlownik),0);
          Inicjuj;
          AktualnyKod:=WezKod(LiczbaBitow);
          While (AktualnyKod<>KoniecDanych) do begin
                if (Aktualnykod=Nowy) then begin
                   Inicjuj;
                   AktualnyKod:=WezKod(LiczbaBitow);
                   Slownik^[Poziom-1].Dana:=AktualnyKod;
                   PoprzedniKod:=AktualnyKod;
                   Na_Ekran(AktualnyKod);
                end else begin
                    Tymczasowy:=AktualnyKod;
                    if (AktualnyKod>=Poziom) then begin
                       AktualnyKod:=PoprzedniKod;
                       Stos^[PoziomStosu]:=Slownik^[Poziom-1].Dana;
                       Inc(PoziomStosu);
                    end;
                    While (AktualnyKod>=OdPoziomu) do begin
                          Stos^[PoziomStosu]:=Slownik^[Aktualnykod].Dana;
                          AktualnyKod:=Slownik^[AktualnyKod].Poziom;
                          Inc(PoziomStosu);
                    end;
                    Stos^[PoziomStosu]:=AktualnyKod;
                    Inc(PoziomStosu);
                    While (PoziomStosu>0) do begin
                          Dec(PoziomStosu);
                          Na_Ekran(Stos^[PoziomStosu]);
                    end;
                    Slownik^[Poziom].Poziom:=PoprzedniKod;
                    Slownik^[Poziom].Dana:=AktualnyKod;
                    Inc(Poziom);
                    PoprzedniKod:=Tymczasowy;
                    if (Poziom SHR LiczbaBitow>0) AND (LiczbaBitow<12) then
                       Inc(LiczbaBitow);
                end;
                AktualnyKod:=WezKod(LiczbaBitow);
          end;
          AktualnyKod:=WezKod(LiczbaBitow);
          end;

Procedure TGIF.OminRozszerzenie;
Var b:byte;
    s:string;
begin
          b:=WezBajt;
          b:=WezBajt;
          While (b>0) do begin
                WezBlok(s,b);
                b:=WezBajt;
          end;
          end;

Procedure TGIF.WezProlog;
Var b:byte;
begin
          WezBlok(Prolog,SizeOF(Prolog));
          b:=Prolog.PoleBitowe;
          JestMapa[Globalny]:=(b AND $80>0);
          LiczbaKolorow[Globalny]:=1 SHL (b AND $07+1);
          BitowNaKolor:=(b AND $7f) SHR 4+1;

          {*** Init ImageAttr ***}

          ImageAttribute.Colors:=1 SHL (b AND $07+1);
          ImageAttribute.Width:=Prolog.SzerokoscEkranu;
          ImageAttribute.Height:=Prolog.WysokoscEkranu;
          end;

Procedure TGIF.WezOpisObrazu;
Var b:byte;
begin
          WezBlok(OpisObr,SizeOF(OpisObr));
          b:=OpisObr.PoleBitowe;
          JestMapa[Lokalny]:=(b AND $80>0);
          LiczbaKolorow[Lokalny]:=1 SHL (b AND $07+1);
          Przeplatany:=(b AND $40>0);
          MaxX:=OpisObr.SzerokoscObrazu-1;
          MaxY:=OpisObr.WysokoscObrazu-1;
          end;

Procedure TGIF.WezKolory;
Var Ile:word;
    Plik:text;
begin
          Ile:=LiczbaKolorow[MapaKolorow];
          Ile:=Ile*3;
          WezBlok(Kolory[MapaKolorow],Ile);
          end;

Procedure TGIF.DefiniujKolory;
Var w:word;
begin
          For w:=0 to LiczbaKolorow[MapaKolorow]-1 do
              With Kolory[MapaKolorow][w] do begin
                   C:=C SHR 2;
                   Z:=Z SHR 2;
                   N:=N SHR 2;
                   ImagePalette[w,0]:=C;
                   ImagePalette[w,1]:=Z;
                   ImagePalette[w,2]:=N;
              end;
          InitImage;
          end;

Function TGIF.GetAttr(Name:string):shortint;begin
         Assign(f,name);
         {$I-}
         Reset(f,1);
         {$I+}
         if IOResult<>0 then begin
            GetAttr:=erFileNotFound;
            Exit;
         end;
         IleBajtow:=0;
         IndeksBufora:=0;
         WezProlog;
         With Prolog do
              If (Naglowek<>'GIF87a') AND (Naglowek<>'GIF89a') then begin
                 Close(f);
                 GetAttr:=erInvalidImageFormat;
                 Exit;
              end;
         MapaKolorow:=Globalny;
         if JestMapa[Globalny] then WezKolory;

         {*** Init ImageAttr ***}

         ImageAttribute.FileName:=Name;

         Close(f);
         GetAttr:=erOK;
         end;


Function TGIF.Load;begin
         FileMode:=0;
         Assign(f,name);
         {$I-}
         Reset(f,1);
         {$I+}
         if IOResult<>0 then begin
            Load:=erFileNotFound;
            Exit;
         end;
         if (MaxAvail<(SizeOF(TSlownik)+SizeOF(TStos))) then begin
            Load:=erOutOfMemory;
            Exit;
         end;
         New(Slownik);
         New(Stos);
         IleBajtow:=0;
         IndeksBufora:=0;
         XEkr:=0;
         YEkr:=0;
         WezProlog;
         With Prolog do
              If (Naglowek<>'GIF87a') AND (Naglowek<>'GIF89a') then begin
                 Dispose(Slownik);
                 Dispose(Stos);
                 Close(f);
                 Load:=erInvalidImageFormat;
                 Exit;
              end;
         MapaKolorow:=Globalny;
         if JestMapa[Globalny] then WezKolory;

         {*** Init ImageAttr ***}

         ImageAttribute.FileName:=Name;

         {*** Show GIF ***}

         Koniec:=False;
         Repeat
           Etykieta:=WezBajt;
           Case Etykieta of
                $2C:begin
                         WezOpisObrazu;
                         if Przeplatany then begin
                            Linie:=1;
                            NaEkran:=2;
                         end else
                            NaEkran:=1;
                         if JestMapa[Lokalny] then begin
                            MapaKolorow:=Lokalny;
                            Wezkolory;
                         end;
                         DefiniujKolory;
                         XEkr:=0;
                         YEkr:=0;
                         Rozpakuj;
                         MapaKolorow:=Globalny;
                end;
                $21:OminRozszerzenie;
                $00,$3B:Koniec:=True;
           end;
         Until Koniec;
         Dispose(Slownik);
         Dispose(Stos);
         Close(f);
         Load:=erOK;
         end;

Procedure TGIF.InitImage;begin
          SetAllPalette(ImagePalette);
          end;

Procedure TGIF.OutData(Line:array of byte;Width,LineCount:word);begin
          end;

{ TGIF }

Constructor TTIF.Init;begin
            FillChar(TIFHead,SizeOF(TIFHead),0);
            FillChar(TIFHead1,SizeOF(TIFHead1),0);
            FillChar(TIFPalette,SizeOF(TIFPalette),0);
            end;

Destructor TTIF.Done;begin
           FillChar(TIFHead,SizeOF(TIFHead),0);
           FillChar(TIFHead1,SizeOF(TIFHead1),0);
           FillChar(TIFPalette,SizeOF(TIFPalette),0);
           end;

Function TTIF.GetAttr(Name:string):shortint;
Var f:file;
    ImageSize:longint;
begin
         FileMode:=0;
         Assign(f,Name);
         {$I-}
         Reset(f,1);
         {$I+}
         if IOResult<>0 then begin
            GetAttr:=erFileNotFound;
            Exit;
         end;
         ImageSize:=FileSize(f);
         {$I-}
         BlockRead(f,TIFHead,SizeOF(TIFHead));
         Seek(f,ImageSize-138);
         BlockRead(f,TIFHead1,SizeOF(TIFHead1));
         {$I+}
         if IOResult<>0 then begin
            GetAttr:=erReadError;
            Close(f);
            Exit;
         end;
         Close(f);
         if ((TIFHead.IFFType[1]<>$49) OR (TIFHead.IFFType[2]<>$49)) then begin
            GetAttr:=erInvalidImageFormat;
            Exit;
         end;

         {*** Init ImageAttr ***}

         ImageAttribute.FileName:=Name;
         ImageAttribute.Width:=TIFHead1.Width;
         ImageAttribute.Height:=TIFHead1.Height;
         ImageAttribute.Colors:=1 SHL TIFHead1.BitsPerPixel;

         GetAttr:=erOK;
         end;

Function TTIF.Load(Name:string):shortint;
Var ScrLine:array[0..2048] of byte;
    R,G,B,Krok,TIFByte,z:byte;
    CurX,CurY:integer;
    f:file;
    fb:file of byte;
begin
         FileMode:=0;
         Assign(f,Name);
         {$I-}
         Reset(f,1);
         {$I+}
         if IOResult<>0 then begin
            Load:=erFileNotFound;
            Exit;
         end;
         if GetAttr(Name)<>erOK then begin
            Load:=GetAttr(Name);
            Close(f);
            Exit;
         end;
         if (TIFHead1.BitsPerPixel<>8) then begin
            Load:=erInvalidImageFormat;
            Close(f);
            Exit;
         end;
         {$I-}
         Seek(f,$21);
         BlockRead(f,TIFPalette,SizeOF(TIFPalette)-1);
         {$I+}
         if IOResult<>0 then begin
            Load:=erReadError;
            Close(f);
            Exit;
         end;
         For z:=0 to 255 do begin
             R:=Lo(TIFPalette[0,z]);
             G:=Lo(TIFPalette[1,z]);
             B:=Lo(TIFPalette[2,z]);
             R:=R SHR 2;
             G:=G SHR 2;
             B:=B SHR 2;
             ImagePalette[z,0]:=R;
             ImagePalette[z,1]:=G;
             ImagePalette[z,2]:=B;
         end;

         InitImage;

         {*** Show TIF ***}

         if (TIFHead1.Compression=$80) then begin
            Close(f);
            Assign(fb,Name);
            Reset(fb);
            Seek(fb,$0620);
            CurY:=0;
            {$I-}
            Repeat
            CurX:=0;
            Repeat
              Read(fb,TIFByte);
              if IOResult<>0 then begin
                 Load:=erReadError;
                 Close(fb);
                 Exit;
              end;
              if (TIFByte and $80)=$80 then begin
                 Krok:=(255-TIFByte)+2;
                 Read(fb,TIFByte);
                 if IOResult<>0 then begin
                    Load:=erReadError;
                    Close(fb);
                    Exit;
                 end;
                 For z:=1 to Krok do begin
                     ScrLine[Curx]:=TIFByte;
                     Inc(CurX);
                 end;
              end else begin
                  Krok:=TIFByte+1;
                  For z:=1 to Krok do begin
                      Read(fb,TIFByte);
                      if IOResult<>0 then begin
                         Load:=erReadError;
                         Close(fb);
                         Exit;
                      end;
                      ScrLine[Curx]:=TIFByte;
                      Inc(CurX);
                  end;
              end;
            Until (CurX>=TIFHead1.Width);
            OutData(ScrLine,TIFHead1.Width,CurY);
            Inc(CurY);
            Until (CurY>=TIFHead1.Height);
            Close(fb);
         end else begin
            {$I-}
            Seek(f,$0620);
            {$I+}
            if IOResult<>0 then begin
               Load:=erReadError;
               Close(f);
               Exit;
            end;
            For CurY:=0 to (TIFHead1.Height-1) do begin
                {$I-}
                BlockRead(f,ScrLine,TIFHead1.Width);
                {$I+}
                if IOResult<>0 then begin
                   Load:=erReadError;
                   Close(f);
                   Exit;
                end;
                OutData(ScrLine,TIFHead1.Width,CurY);
            end;
            Close(f);
         end;
         Load:=erOK;
         end;

Procedure TTIF.InitImage;begin
          SetAllPalette(ImagePalette);
          end;

Procedure TTIF.OutData(Line:array of byte;Width,LineCount:word);begin
          end;

{ TWPG }

Constructor TWPG.Init;begin
            FillChar(WPGHead,SizeOF(WPGHead),0);
            FillChar(WPGHead1,SizeOF(WPGHead1),0);
            FillChar(WPGPalette,SizeOF(WPGPalette),0);
            end;

Destructor TWPG.Done;begin
           FillChar(WPGHead,SizeOF(WPGHead),0);
           FillChar(WPGHead1,SizeOF(WPGHead1),0);
           FillChar(WPGPalette,SizeOF(WPGPalette),0);
           end;

Function TWPG.GetAttr(Name:string):shortint;
Var f:file;
begin
           FileMode:=0;
           Assign(f,Name);
           {$I-}
           Reset(f,1);
           {$I+}
           if IOResult<>0 then begin
              GetAttr:=erFileNotFound;
              Exit;
           end;
           {$I-}
           BlockRead(f,WPGHead,SizeOF(WPGHead));
           if (WPGHead.Start<>$ff) OR (WPGHead.WPGType<>'WPC') then begin
              GetAttr:=erInvalidImageFormat;
              Close(f);
              Exit;
           end;
           Seek(f,$20+768);
           BlockRead(f,WPGHead1,SizeOF(WPGHead1));
           {$I+}
           if IOResult<>0 then begin
              GetAttr:=erReadError;
              Exit;
           end;
           Close(f);

           {*** Init ImageAttr ***}

           ImageAttribute.FileName:=Name;
           ImageAttribute.Width:=WPGHead1.Width;
           ImageAttribute.Height:=WPGHead1.Height;
           if (WPGHead.Colors=$ff) then
              ImageAttribute.Colors:=256;
           if (WPGHead.Colors=$34) then
              ImageAttribute.Colors:=16;

           GetAttr:=erOK;
           end;

Function TWPG.Load(Name:string):shortint;
Var ScrLine:array[0..2048] of byte;
    Er:shortint;
    WPGByte,Krok,z:byte;
    CurX,CurY:integer;
    f:file;
    fb:file of byte;
begin
           FileMode:=0;
           Assign(f,Name);
           {$I-}
           Reset(f,1);
           {$I+}
           if IOResult<>0 then begin
              Load:=erFileNotFound;
              Exit;
           end;
           if GetAttr(Name)<>erOK then begin
              Load:=GetAttr(Name);
              Exit;
           end;
           {$I-}
           Seek(f,$20);
           BlockRead(f,WPGPalette,SizeOF(WPGPalette));
           {$I+}
           if IOResult<>0 then begin
              Load:=erReadError;
              Close(f);
              Exit;
           end;
           For z:=0 to 255 do begin
               ImagePalette[z,0]:=WPGPalette[(z*3)] SHR 2;
               ImagePalette[z,1]:=WPGPalette[(z*3)+1] SHR 2;
               ImagePalette[z,2]:=WPGPalette[(z*3)+2] SHR 2;
           end;
           Close(f);

           InitImage;

           {*** Show WPG ***}

           Assign(fb,Name);
           Reset(fb);
           Seek(fb,$0330);
           CurY:=0;
           {$I-}
           Repeat
           CurX:=0;
           Repeat
             Read(fb,WPGByte);
             if IOResult<>0 then begin
                Load:=erReadError;
                Close(fb);
                Exit;
             end;
             if (WPGByte and $80)=$80 then begin
                Krok:=(WPGByte AND $7f);
                Read(fb,WPGByte);
                if IOResult<>0 then begin
                   Load:=erReadError;
                   Close(fb);
                   Exit;
                end;
                For z:=1 to Krok do begin
                    ScrLine[Curx]:=WPGByte;
                    Inc(CurX);
                end;
             end else begin
                 Krok:=WPGByte;
                 For z:=1 to Krok do begin
                     Read(fb,WPGByte);
                     if IOResult<>0 then begin
                        Load:=erReadError;
                        Close(fb);
                        Exit;
                     end;
                     ScrLine[Curx]:=WPGByte;
                     Inc(CurX);
                 end;
             end;
           Until (CurX>=WPGHead1.Width);
           OutData(ScrLine,WPGHead1.Width,CurY);
           Inc(CurY);
           Until (CurY>=WPGHead1.Height);
           Close(fb);
           Load:=erOK;
           end;

Procedure TWPG.InitImage;begin
          SetAllPalette(ImagePalette);
          end;

Procedure TWPG.OutData(Line:array of byte;Width,LineCount:word);begin
          end;

{ TTGA }

Constructor TTGA.Init;begin
            FillChar(TGAHead,SizeOF(TGAHead),0);
            FillChar(TGAPalette,SizeOF(TGAPalette),0);
            end;

Destructor TTGA.Done;begin
           FillChar(TGAHead,SizeOF(TGAHead),0);
           FillChar(TGAPalette,SizeOF(TGAPalette),0);
           end;

Function TTGA.GetAttr(Name:string):shortint;
Var f:file;
    FileSize:longint;
begin
           FileMode:=0;
           Assign(f,Name);
           {$I-}
           Reset(f,1);
           {$I+}
           if IOResult<>0 then begin
              GetAttr:=erFileNotFound;
              Exit;
           end;
           {$I-}
           BlockRead(f,TGAHead,SizeOF(TGAHead));
           {$I+}
           if IOResult<>0 then begin
              GetAttr:=erReadError;
              Close(f);
              Exit;
           end;
           Close(f);

           {*** Init ImageAttr ***}

           ImageAttribute.FileName:=Name;
           ImageAttribute.Width:=TGAHead.Width;
           ImageAttribute.Height:=TGAHead.Height;
           ImageAttribute.Colors:=1 SHL TGAHead.Bits;

           GetAttr:=erOK;
           end;

Function TTGA.Load(Name:string):shortint;
Var ScrLine:array[0..2048] of byte;
    R,R1,G,B,z:byte;
    y:word;
    f:file;
begin
           FileMode:=0;
           Assign(f,Name);
           {$I-}
           Reset(f,1);
           {$I+}
           if IOResult<>0 then begin
              Load:=erFileNotFound;
              Exit;
           end;
           if GetAttr(Name)<>erOK then begin
              Load:=GetAttr(Name);
              Close(f);
              Exit;
           end;
           if ((TGAHead.TGAType[1]<>$00) AND
               (TGAHead.TGAType[2]<>$01) AND
               (TGAHead.TGAType[3]<>$01) AND
               (TGAHead.TGAType[4]<>$00)) OR
               (TGAHead.Bits<>8) then begin
              Load:=erInvalidImageFormat;
              Close(f);
              Exit;
           end;

           {*** Load and convert palette ***}

           {$I-}
           Seek(f,$12);
           BlockRead(f,TGAPalette,SizeOF(TGAPalette));
           {$I+}
           if IOResult<>0 then begin
              Load:=erReadError;
              Close(f);
              Exit;
           end;
           For z:=0 to 255 do begin
               R:=TGAPalette[(z*3)] SHR 2;
               G:=TGAPalette[(z*3)+1] SHR 2;
               B:=TGAPalette[(z*3)+2] SHR 2;
               R1:=R;
               R:=B;
               B:=R1;
               ImagePalette[z,0]:=R;
               ImagePalette[z,1]:=G;
               ImagePalette[z,2]:=B;
           end;

           InitImage;

           {*** Show TGA ***}

           For y:=0 to (TGAHead.Height-1) do begin
               {$I-}
               BlockRead(f,ScrLine,TGAHead.Width);
               {$I+}
               if IOResult<>0 then begin
                  Load:=erReadError;
                  Close(f);
                  Exit;
               end;
               OutData(ScrLine,TGAHead.Width,y);
           end;
           Close(f);
           Load:=erOK;
           end;

Function TTGA.Save(Width,Height:word;Name:string):shortint;
Var ScrLine:array[0..2048] of byte;
    Pal:TVGAPalette;
    R,R1,G,B,z:byte;
    y:integer;
    f:file;
begin
           Assign(f,Name);
           {$I-}
           Rewrite(f,1);
           {$I+}
           if IOResult<>0 then begin
              Save:=erWriteError;
              Exit;
           end;

           {*** Init TGAHead ***}

           TGAHead.TGAType[1]:=$00;
           TGAHead.TGAType[2]:=$01;
           TGAHead.TGAType[3]:=$01;
           TGAHead.TGAType[4]:=$00;
           TGAHead.Fill[5]:=$00;
           TGAHead.Fill[6]:=$00;
           TGAHead.Fill[7]:=$01;
           TGAHead.Fill[8]:=$18;
           TGAHead.Fill[9]:=$00;
           TGAHead.Fill[10]:=$00;
           TGAHead.Fill[11]:=$00;
           TGAHead.Fill[12]:=$00;
           TGAHead.Width:=Width;
           TGAHead.Height:=Height;
           TGAHead.Bits:=$08;
           TGAHead.Fill1:=$20;
           {$I-}
           BlockWrite(f,TGAHead,SizeOF(TGAHead));
           {$I+}
           if IOResult<>0 then begin
              Save:=erWriteError;
              Close(f);
              Exit;
           end;

           {*** Get and convert palette ****}

           GetAllPalette(Pal);
           FillChar(TGAPalette,SizeOF(TGaPalette),0);
           For z:=0 to 255 do begin
               R:=Pal[z,0] SHL 2;
               G:=Pal[z,1] SHL 2;
               B:=Pal[z,2] SHL 2;
               R1:=R;
               R:=B;
               B:=R1;
               TGAPalette[(z*3)]:=R;
               TGAPalette[(z*3)+1]:=G;
               TGAPalette[(z*3)+2]:=B;
           end;
           {$I-}
           BlockWrite(f,TGAPalette,SizeOF(TGAPalette));
           {$I+}
           if IOResult<>0 then begin
              Save:=erWriteError;
              Close(f);
              Exit;
           end;

           {*** Save TGA ***}

           For y:=0 to (TGAHead.Height-1) do begin
               InData(ScrLine,TGAHead.Width,y);
               {$I-}
               BlockWrite(f,ScrLine,TGAHead.Width);
               {$I+}
               if IOResult<>0 then begin
                  Save:=erWriteError;
                  Close(f);
                  Exit;
               end;
           end;
           Close(f);
           Save:=erOK;
           end;

Procedure TTGA.InitImage;begin
          SetAllPalette(ImagePalette);
          end;

Procedure TTGA.OutData(Line:array of byte;Width,LineCount:word);begin
          end;

Procedure TTGA.InData(Var Line:array of byte;Width,LineCount:word);begin
          end;

{ TICO }

Constructor TICO.Init;begin
            end;

Destructor TICO.Done;begin
           end;

Function TICO.Load(Name:string):shortint;
Var ScrLine:array[1..31] of byte;
    b,z1: byte;
    p: pointer;
    z: integer;
    f: file;
begin
           FileMode:=0;
           Assign(f,name);
           {$I-}
           Reset(f,1);
           {$I+}
           if IOResult<>0 then begin
              Load:=erFileNotFound;
              Exit;
           end;
           if (MaxAvail<512) then begin
              Load:=erOutOfMemory;
              Exit;
           end;
           GetMem(p,512);
           {$I-}
           Seek(f,126);
           BlockRead(f,p^,512,z);
           {$I+}
           if IOResult<>0 then begin
              Load:=erReadError;
              Exit;
           end;
           Close(f);
           if (z<>512) then begin
              FreeMem(p,512);
              Load:=erInvalidImageFormat;
              Exit;
           end;
           For z:=31 downto 0 do begin
               z1:=0;
               repeat
                 b:=mem[ seg(p^):ofs(p^)+z*16+z1 div 2];
                 ScrLine[z1]:=b SHR 4;
                 ScrLine[z1+1]:=b AND 15;
                 z1:=z1+2;
                Until z1>=31;
                OutData(ScrLine,31,31-z);
           end;
           FreeMem(p,512);
           Load:=erOK;
           end;

Procedure TICO.OutData(Line:array of byte;Width,LineCount:word);begin
          end;

{ TLoadGIF }

Constructor TLoadGIF.Init(AOutBuffer:pointer);begin
            Inherited Init;
            OutBuffer:=PImageBuffer(AOutBuffer);
            end;

Procedure TLoadGIF.InitImage;begin
          end;

Procedure TLoadGIF.OutData(Line:array of byte;Width,LineCount:word);begin
          Move(Line,OutBuffer^[(LineCount*Width)],Width);
          end;

{ TLoadCEL }

Constructor TLoadCEL.Init(AOutBuffer:pointer);begin
            Inherited Init;
            OutBuffer:=PImageBuffer(AOutBuffer);
            end;

Procedure TLoadCEL.InitImage;begin
          end;

Procedure TLoadCEL.OutData(Line:array of byte;Width,LineCount:word);begin
          Move(Line,OutBuffer^[(LineCount*Width)],Width);
          end;

{ TLoadPCX }

Constructor TLoadPCX.Init(AOutBuffer:pointer);begin
            Inherited Init;
            OutBuffer:=PImageBuffer(AOutBuffer);
            end;

Procedure TLoadPCX.InitImage;begin
          end;

Procedure TLoadPCX.OutData(Line:array of byte;Width,LineCount:word);begin
          Move(Line,OutBuffer^[(LineCount*Width)],Width);
          end;

{*** Other ***}

Function FastLoadPCX320x200(Name:string;Var Buf;Var Pal:TVGAPalette;Var W,H:word):shortint;

Var PCXHead : TPCXHead;
    PCXExtPalette : TPCXExtPalette;
    PCXByte,x,Count:byte;
    Size,ReadOffset,ReadBytes:longint;
    WriteSeg,WriteOfs:word;
    f:file;
    I : pointer;

Function GetAttr(Name:string):shortint;
Var z:word;
    f:file;
begin
         FileMode:=0;
         Assign(f,Name);
         {$I-}
         Reset(f,1);
         {$I+}
         if IOResult<>0 then begin
            GetAttr:=erFileNotFound;
            Close(f);
            Exit;
         end;
         {$I-}
         BlockRead(f,PCXHead,SizeOf(PCXHead));

         {*** Check if 256 colors ***}

         if (PCXHead.BitsPerPixel=8) then begin
            Seek(f,FileSize(f)-768);
            BlockRead(f,PCXExtPalette,SizeOF(PCXExtPalette));
            For z:=0 to 767 do
                PCXExtPalette[z]:=PCXExtPalette[z] SHR 2;
         end;

         {$I+}
         if IOResult<>0 then begin
            GetAttr:=erReadError;
            Close(f);
            Exit;
         end;
         Close(f);

         GetAttr:=erOK;
         end;

Function GetByte(Var B:byte):shortint;
Var R:word;
begin
         if (ReadOffset>2048-1) then begin
            {$I-}
            BlockRead(f,I^,2048,R);
            {$I+}
            if IOResult<>0 then begin
               GetByte:=erReadError;
               Exit;
            end;
            ReadOffset:=0;
         end;
         B:=Mem[Seg(I^):Ofs(I^)+ReadOffset];
         Inc(ReadOffset);
         Inc(ReadBytes);
         GetByte:=erOK;
         end;
begin
         if (MaxAvail<2048) then begin
            FastLoadPCX320x200:=erOutOfMemory;
            Exit;
         end;
         FileMode:=0;
         Assign(f,Name);
         {$I-}
         Reset(f,1);
         {$I+}
         if IOResult<>0 then begin
            FastLoadPCX320x200:=erFileNotFound;
            Close(f);
            Exit;
         end;
         if (GetAttr(Name)<>erOK) then begin
            FastLoadPCX320x200:=GetAttr(Name);
            Close(f);
            Exit;
         end;

         if (PCXHead.BitsPerPixel<>8) then begin
            FastLoadPCX320x200:=erInvalidImageFormat;
            Close(f);
            Exit;
         end;

         GetMem(I,2048);

         {*** Read PCX ***}

         Size:=FileSize(f)-128-SizeOF(TPCXExtPalette)-1;
         ReadBytes:=0;
         ReadOffset:=99999;
         WriteSeg:=Seg(Buf);
         WriteOfs:=Ofs(Buf);
         Seek(f,128);

         Repeat

          {*** Decoding pcx ***}

          if (GetByte(PCXByte)<>erOK) then begin
             FastLoadPCX320x200:=erReadError;
             FreeMem(I,2048);
             Close(f);
             Exit;
          end;
          if (PCXByte and $c0)=$c0 then begin
             Count:=PCXByte and $3f;
             if (GetByte(PCXByte)<>erOK) then begin
                FastLoadPCX320x200:=erReadError;
                FreeMem(I,2048);
                Close(f);
                Exit;
             end;
             for x:=1 to Count do begin
                 Mem[WriteSeg:WriteOFs]:=PCXByte;
                 Inc(WriteOfs);
             end;
          end else begin
             Mem[WriteSeg:WriteOfs]:=PCXByte;
             Inc(WriteOfs)
          end;

         Until (ReadBytes>=Size);
         FreeMem(I,2048);
         Close(f);
         Move(PCXExtPalette,Pal,SizeOF(TPCXExtPalette));
         W:=PCXHead.XMax;
         H:=PCXHead.Ymax;
         FastLoadPCX320x200:=erOK;
         end;

begin
ImageBuffer:=NIL;
end.









