{------------------------------------------------------------------------}
{-                                                                      -}
{-                      "Texturowanie perspektywiczne"                  -}
{-                                                                      -}
{-                              Made by Dreddi                          -}
{-                                                                      -}
{------------------------------------------------------------------------}

Uses Errors,Image,VGAPal,Crt;

Const { Klipowanie polygona do ekranu }

      ClipMinX          = 0;
      ClipMaxX          = 319;
      ClipTopY          = 0;
      ClipBottomY       = 199;
      xcenter           = 160;
      ycenter           = 100;

      { Minimalny dystans }

      MinZDistance      = 20;

      { Scala }

      MaxScale          = 165;

Type  { Bufor na spany }

      TSpan      = array[1..2] of integer;
      TSpanArray = array[0..480] of TSpan;

      { Jeden wierzcholek }

      TVertex = record
        x,y,z : single;
      end;

      { Polygon }

      PPoly4 = ^TPoly4;
      TPoly4 = record
        VertCnt  : byte;                   { ilosc wierzcholkow   }
        V        : array[1..5] of TVertex; { wierzcholki          }
        O,T,S    : TVertex;                { wektory textury      }
      end;

Var 
    { Aktualnie renderowany polygon }

    Spans       : TSpanArray;
    PRx         : array[1..5] of single;
    PRy         : array[1..5] of single;
    PRz         : array[1..5] of single;
    VertCnt     : byte;
    PolyVisible : boolean;
    TopY        : integer;
    BottomY     : integer;
    _textwidth  : word;
    _textheight : word;

    _poly_O     : TVertex;         { wektory textury }
    _poly_H     : TVertex;
    _poly_V     : TVertex;

    PolyN       : TVertex;         { wektor normalny }

    { Obserwator }

    xo,yo,zo    : single;
    Ax,Ay       : single;

    { Program }

    p,Texture   : pointer;
    Pal         : TVGAPalette;
    Width       : word;
    Height      : word;

    TestPoly    : TPoly4;

    Key         : char;

{/-- Uff...matematyka --/}
Procedure CrossProduct(A,B:TVertex;Var O:TVertex);begin
          O.x:=(A.y*B.z)-(A.z*B.y);
          O.y:=(A.z*B.x)-(A.x*B.z);
          O.z:=(A.x*B.y)-(A.y*B.x);
          end;

Function DotProduct(A,B:TVertex):single;begin
         DotProduct:=(A.x*B.x)+(A.y*B.y)+(A.z*B.z);
         end;

Function VectorLength(A:TVertex):single;begin
         VectorLength:=Sqrt(Sqr(A.X)+Sqr(A.Y)+Sqr(A.Z));
         end;

Procedure Normalize(Var A:TVertex);
Var l,_1l:single;
begin
         l:=VectorLength(A);
         if (l<>0) then begin
            _1l:=1/l;
            A.x:=A.x*_1l;
            A.y:=A.y*_1l;
            A.z:=A.z*_1l;
         end else begin
            A.x:=0;
            A.y:=0;
            A.z:=0;
         end;
         end;

Procedure FaceNormal(x1,y1,z1,x2,y2,z2,x3,y3,z3:single;Var xn,yn,zn:single);
Var vx,vy,vz,wx,wy,wz:single;
begin
          vx:=x2-x1;
          vy:=y2-y1;
          vz:=z2-z1;

          wx:=x3-x2;
          wy:=y3-y2;
          wz:=z3-z2;

          xn:=(vy*wz)-(vz*wy);
          yn:=(vz*wx)-(vx*wz);
          zn:=(vx*wy)-(vy*wx);
          end;

Function IsFaceVisible(X1,Y1,X2,Y2,X3,Y3:extended):extended;begin
         IsFaceVisible:=((y1-y3)*(x2-x1))-((x1-x3)*(y2-y1));
         end;

{/-- Przygotowanie spanow --/}
Procedure PrepareSpans_SLOW;
var miny,maxy,minx,maxx : integer;
    x,y:array[1..10] of integer;
    i:integer;

Procedure doside (x1,y1,x2,y2:integer);

VAR temp:integer;
    xr,xinc:single;
    x:longint;
    i:integer;
BEGIN
  if y1=y2 then exit;
  if y2<y1 then
   BEGIN
     temp:=y2;
     y2:=y1;
     y1:=temp;
     temp:=x2;
     x2:=x1;
     x1:=temp;
   END;

  xinc:=(x2-x1)/(y2-y1); {xinc w fixed point}
  xr:=x1;
  for i:=Round(y1) to Round(y2) do BEGIN
    if (i>=(ClipTopY)) and (i<=(ClipBottomY)) then
      BEGIN
        x := Round(xr);
        if (x<Spans[i,1]) then
         begin
           if (x<ClipMinX) then x:=ClipMinX;
           Spans[i,1]:=x;
         end;
        if (x>Spans[i,2]) then
         begin
           if (x>ClipMaxX) then x:=ClipMaxX;
           Spans[i,2]:=x;
         end;
      END;
    xr:=xr+xinc;
  END;
END;

begin

  PolyVisible:=false;

  {/-- Ustaw spanu na maximum --/}

  For i := 0 to 199 do begin
     Spans[i,1] :=32766;
     Spans[i,2] :=-32767;
  end;

  For i:=1 to VertCnt do begin
      x[i]:=Round(PRx[i]);
      y[i]:=Round(PRy[i]);
  end;

  {/-- Znajdz maxymaly i minimalny X --/}

  minx:=x[1];
  maxx:=x[1];
  For i:=1 to VertCnt do begin
      if x[i]<minx then
         minx:=x[i];
      if x[i]>maxx then
         maxx:=x[i];
  end;

  {/-- Czy wychodzi calkowicie za ekran? --/}

  if (minx>ClipMaxX) or (maxx<ClipMinX) then exit;

  if minx<ClipMinX then minx:=ClipMinX;
  if maxx>ClipMaxX then maxx:=ClipMaxX;

  {/-- Znajdz maxymaly i minimalny Y --/}

  miny:=y[1];
  maxy:=y[1];
  For i:=1 to VertCnt do begin
      if y[i]<miny then miny:=y[i];
      if y[i]>maxy then maxy:=y[i];
  end;

  {/-- Czy wychodzi calkowicie za ekran? --/}

  if (miny>ClipBottomY) or (maxy<ClipTopY) then exit;

  if (miny<ClipTopY) then miny:=ClipTopY;
  if (maxy>ClipBottomY) then maxy:=ClipBottomY;

  {/- Scanowanie polygona --/}
  For i:=1 to VertCnt-1 do
      Doside (x[i],y[i],x[i+1],y[i+1]);
  Doside (x[i+1],y[i+1],x[1],y[1]);

  TopY:=miny;
  BottomY:=maxy;

  PolyVisible:=true;

end;

{/-- TEXTUROWANIE --/}
Procedure CorrectTexture_SLOW;
Var x,y,z : single;
    u,v   : integer;
    i,j   : integer;
    pt,P,M,N : TVertex;
    RunStart : integer;
    RunLen   : integer;
    _A       : TVertex;
    _B       : TVertex;
    _C       : TVertex;
begin
          P.x:= _poly_O.x;
          P.y:= _poly_O.y;
          P.z:= _poly_O.z;

          N.x:= (_poly_V.x * _textheight);
          N.y:= (_poly_V.y * _textheight);
          N.z:= (_poly_V.z * _textheight);

          M.x:= -(_poly_H.x * _textwidth);
          M.y:= -(_poly_H.y * _textwidth);
          M.z:= -(_poly_H.z * _textwidth);

          CrossProduct(N, P, _A);
          CrossProduct(M, P, _B);
          CrossProduct(N, M, _C);

          _A.x :=_A.x * _textwidth;
          _A.y :=_A.y * _textwidth;
          _A.z :=_A.z * _textwidth;

          _B.x :=_B.x * _textheight;
          _B.y :=_B.y * _textheight;
          _B.z :=_B.z * _textheight;

          For j:=TopY to BottomY do begin

              if (j>=ClipTopY) AND (j<=ClipBottomY) then begin

                 RunStart:=spans[j,1];
                 RunLen:=spans[j,2]-RunStart;

                 pt.y:=+(j-ycenter);
                 pt.z:=MaxScale;

                 if (RunLen>0) then
                    For i:=1 to RunLen do begin

                        if (RunStart>=ClipMinX) AND (RunStart<=ClipMaxX) then begin

                           pt.x:=RunStart-xcenter;

                           x:=DotProduct(pt,_A);
                           y:=DotProduct(pt,_B);
                           z:=DotProduct(pt,_C);

                           u:=Round(x/z) AND (_textwidth-1);
                           v:=Round(y/z) AND (_textheight-1);

                           Mem[$a000:(j*320)+RunStart]:=Mem[Seg(Texture^):Ofs(Texture^)+(v SHL 8)+u];
                        end;
                        (*
                        if (RunStart>=ClipX1) AND (RunStart<=ClipX2) then begin

                           Mem[$a000:(j*320)+RunStart]:=15;
                        end;
                        *)
                        Inc(RunStart);
                    end;
              end;
          end;
          end;

{/-- TEXTUROWANIE --/}
Procedure CorrectTexture_FAST(Var Txt;TextureSize:byte;MAXINTERPOLATE:word;MIPLevel:byte);
Var x,y,z : single;
    _1z   : single;
    _1024 : single;
    _1INT : single;
    sub_u2_u1 : single;
    sub_v2_v1 : single;

    ainc  : single;
    binc  : single;
    cinc  : single;

    u1,v1 : longint;
    u2,v2 : longint;
    du,dv : longint;

    i,j   : integer;
    pt,P,M,N : TVertex;
    RunStart : integer;
    RunLen   : integer;
    ShortRun : integer;
    CXCount  : word;
    W        : word;
    ANDlevel : word;
    BAddr    : pointer;
    _A       : TVertex;
    _B       : TVertex;
    _C       : TVertex;

    _DS : word;
begin
          P.x:= _poly_O.x;
          P.y:= _poly_O.y;
          P.z:= _poly_O.z;

          N.x:= (_poly_V.x * _textheight);
          N.y:= (_poly_V.y * _textheight);
          N.z:= (_poly_V.z * _textheight);

          M.x:= -(_poly_H.x * _textwidth);
          M.y:= -(_poly_H.y * _textwidth);
          M.z:= -(_poly_H.z * _textwidth);

          CrossProduct(N, P, _A);
          CrossProduct(M, P, _B);
          CrossProduct(N, M, _C);

          _A.x :=_A.x * _textwidth;
          _A.y :=_A.y * _textwidth;
          _A.z :=_A.z * _textwidth;

          _B.x :=_B.x * _textheight;
          _B.y :=_B.y * _textheight;
          _B.z :=_B.z * _textheight;

          _1INT:=1/MAXINTERPOLATE;
          _1024:=1024;

          Dec(TextureSize);
          Case MIPLevel of
               0:ANDLevel:=(TextureSize SHL 8)+TextureSize;
               1:ANDLevel:=((TextureSize-1) SHL 8)+(TextureSize-1);
               2:ANDLevel:=((TextureSize-3) SHL 8)+(TextureSize-3);
          end;

          BAddr:=Ptr($a000,0);

          For j:=Topy to Bottomy do begin

              RunStart:=spans[j,1];
              RunLen:=spans[j,2]-RunStart;

              if (RunLen>0) then begin

                 W:=(j*320)+RunStart;

                 pt.x:=RunStart-xcenter+1;
                 pt.y:=j-ycenter;
                 pt.z:=MAXSCALE;

                 x:=DotProduct(pt,_A);
                 y:=DotProduct(pt,_B);
                 z:=DotProduct(pt,_C);

                 if (Abs(z)>100) then begin

                    asm
                    fld _1024
                    fdiv z
                    fstp _1z        { _1z=1024*z }

                    fld _1z
                    fld st(0)
                    fmul  x
                    fistp u1        { u1:=Round(x*_1z) }
                    fmul  y         { u1:=Round(x*_1z) }
                    fistp v1

                    fld _A.x
                    fimul MAXINTERPOLATE
                    fstp ainc           { ainc=_A.x*MAXINTERPOLATE }

                    fld _B.x
                    fimul MAXINTERPOLATE
                    fstp binc           { binc=_B.x*MAXINTERPOLATE }

                    fld _C.x
                    fimul MAXINTERPOLATE
                    fstp cinc           { cinc=_C.x*MAXINTERPOLATE }

                    fld x
                    fadd ainc
                    fstp x        { x=x+ainc }

                    fld y
                    fadd binc
                    fstp y        { y=y+binc }

                    fld z
                    fadd cinc
                    fstp z        { z=z+cinc }

                    fld _1024
                    fdiv z
                    fstp _1z        { _1z=1024*z }
                    end;

                    While (RunLen>0) do begin

                       asm
                       mov ax,[RunLen]
                       cmp ax,[MAXINTERPOLATE]
                       jb @Long
                       mov bx,[MAXINTERPOLATE]
                       mov [ShortRun],bx
                       sub [RunLen],bx
                       jmp @end
            @Long:
                       mov [ShortRun],ax
                       mov bx,[MAXINTERPOLATE]
                       sub [RunLen],bx
            @End:

                       end;

                       if (Abs(z)>100) then begin

                          asm
                          fld _1z
                          fld st(0)
                          fmul  x
                          fistp u2   { u2:=Round(x*_1z) }
                          fmul  y
                          fistp v2   { v2:=Round(y*_1z) }

                          db $66; mov ax,word ptr [u2]
                          db $66; mov bx,word ptr [v2]

                          db $66; sub ax,word ptr [u1]
                          db $66; sub bx,word ptr [v1]

                          db $66; mov word ptr [sub_u2_u1],ax
                          db $66; mov word ptr [sub_v2_v1],bx

                          fld _1INT
                          fld st(0)
                          fimul  sub_u2_u1  { du=Round((u2-u1)*_1INT) }
                          fistp du
                          fimul  sub_v2_v1  { dv=Round((v2-v1)*_1INT) }
                          fistp dv

                          fld x
                          fadd ainc
                          fstp x        { x=x+ainc }

                          fld y
                          fadd binc
                          fstp y        { y=y+binc }

                          fld z
                          fadd cinc
                          fstp z        { z=z+cinc }

                          fld _1024
                          fdiv z

                          push ds

                          lds si,dword ptr [Txt]
                          les di,dword ptr [BAddr]
                          add di,[W]

                          mov cx,[ShortRun]
                          mov [CXCount],cx
                          add [W],cx

                          db $66; mov dx,word ptr [u1]    { DX = u1 }
                          db $66; mov bx,word ptr [v1]    { BX = v1 }
                          db $66; mov ax,word ptr [du]
                          db $66; mov cx,word ptr [dv]
                          db $66; shr dx,2
                          db $66; shr bx,2
                          db $66; shr ax,2
                          db $66; shr cx,2

              @Loop:
                          push bx
                          nop

                          mov bl,dh
                          and bx,[ANDLevel]

                          mov bl,[ds:si+bx]
                          add dx,ax

                          mov [es:di],bl
                          inc di

                          pop bx
                          add bx,cx

                          dec [CXCount]
                          jne @Loop

                          pop ds

                          fstp _1z

              @ZaDuzo:
                          end;

                       end;

                       u1:=u1+(ShortRun*du);
                       v1:=v1+(ShortRun*dv);

                    end; { While }
                 end;

              end;

          end; { For }

          end;

{/-- Rzutowanie polygona --/}

Procedure MoveVectors3(Var Scr,Dest);assembler;
          asm
          push ds
          lds si,dword ptr [Scr]
          les di,dword ptr [Dest]

          mov cx,3

          db $66; rep movsw
          pop ds
          end;

Procedure MoveVector(Var Scr,Dest);assembler;
          asm
          push ds
          lds si,dword ptr [Scr]
          les di,dword ptr [Dest]

          mov cx,3

          db $66; rep movsw
          pop ds
          end;

Procedure MovePoly(PS:TPoly4);
Var i:byte;
begin
          For i:=1 to PS.VertCnt do begin
              PRx[i]:=PS.V[i].x+xo;
              PRy[i]:=PS.V[i].y+yo;
              PRz[i]:=PS.V[i].z+zo;
          end;
          VertCnt:=PS.VertCnt;
          end;

Procedure MoveTextureVectors(PS:TPoly4);begin

          _poly_O.x:=PRx[1]+PS.O.x;
          _poly_O.y:=PRy[1]+PS.O.y;
          _poly_O.z:=PRz[1]+PS.O.z;

          MoveVectors3(PS.S,_Poly_H);
          MoveVectors3(PS.T,_Poly_V);
          end;

Procedure RotatePoly;
Var i:byte;
    nx,ny,nz,_ny:single;
begin
          For i:=1 to VertCnt do begin
              nx:=(PRx[i]*Cos(Ay))+(PRz[i]*Sin(Ay));
              _ny:=PRy[i];
              nz:=(PRz[i]*Cos(Ay))-(PRx[i]*Sin(Ay));

              ny:=(_ny*Cos(Ax))+(nz*Sin(Ax));
              nz:=(nz*Cos(Ax))-(_ny*Sin(Ax));

              PRx[i]:=nx;
              PRy[i]:=ny;
              PRz[i]:=nz;
          end;
          end;

Procedure RotateTextureVectors;
Var i:byte;
    _ny:single;
    n:TVertex;
begin
          {/// _poly_O ///}

          n.x:=(_poly_O.x*Cos(Ay))+(_poly_O.z*Sin(Ay));
          _ny:=_poly_O.y;
          n.z:=(_poly_O.z*Cos(Ay))-(_poly_O.x*Sin(Ay));

          n.y:=(_ny*Cos(Ax))+(n.z*Sin(Ax));
          n.z:=(n.z*Cos(Ax))-(_ny*Sin(Ax));

          MoveVector(n,_poly_O);

          {/// _poly_H ///}

          n.x:=(_poly_H.x*Cos(Ay))+(_poly_H.z*Sin(Ay));
          _ny:=_poly_H.y;
          n.z:=(_poly_H.z*Cos(Ay))-(_poly_H.x*Sin(Ay));

          n.y:=(_ny*Cos(Ax))+(n.z*Sin(Ax));
          n.z:=(n.z*Cos(Ax))-(_ny*Sin(Ax));

          MoveVector(n,_poly_H);

          {/// _poly_V ///}

          n.x:=(_poly_V.x*Cos(Ay))+(_poly_V.z*Sin(Ay));
          _ny:=_poly_V.y;
          n.z:=(_poly_V.z*Cos(Ay))-(_poly_V.x*Sin(Ay));

          n.y:=(_ny*Cos(Ax))+(n.z*Sin(Ax));
          n.z:=(n.z*Cos(Ax))-(_ny*Sin(Ax));

          MoveVector(n,_poly_V);
          end;

Procedure DoClipping;
Var i:byte;
    Zsr:single;
begin

          {// Z testing //}
          PolyVisible:=true;
          For i:=1 to VertCnt do
              if (PRz[i]<=MinZDistance) then begin
                 PolyVisible:=false;
                 Exit;
              end;

          end;

Procedure ApplyPerspective;
Var i:byte;
    _1z:single;
begin
          {/-- Perspectywa i centrowanie --/}

          For i:=1 to VertCnt do begin
              _1z:=MAXSCALE/PRz[i];
              PRx[i]:=Round(PRx[i]*_1z)+xcenter;
              PRy[i]:=Round(PRy[i]*_1z)+ycenter;
          end;
          end;

{/-- Rzutuj --/}
Procedure ProjectPoly(P:TPoly4);
Var A:TVertex;
begin

          {/-- Przesun polygona --/}
          MovePoly(P);

          {/-- Przesun wektory textury --/}
          MoveTextureVectors(P);

          {/-- Obrot polygona --/}
          RotatePoly;

          {/-- Obrot wektorow textury ( poprobuj to ominac ) --/}
          RotateTextureVectors;

          {/-- Proste klipowanie --/}
          DoClipping;

          {/-- Jesli polygon nadal widoczny to dalej... --/}
          if PolyVisible then begin

             {/-- Czy widoczny --/}
             FaceNormal(PRx[1],PRy[1],PRz[1],
                        PRx[2],PRy[2],PRz[2],
                        PRx[3],PRy[3],PRz[3],PolyN.x,PolyN.y,PolyN.z);
             Normalize(PolyN);

             A.X:=PRx[1];
             A.Y:=PRy[1];
             A.Z:=PRz[1];

             if (DotProduct(PolyN,A)>0) then begin

                {/-- TAAAAK!.Widoczny --/}

                ApplyPerspective;

             end else

                PolyVisible:=false;

          end;

          end;

{/-- Renderacja polygona --/}
Procedure ShowPoly(P:TPoly4);begin

          ProjectPoly(P);

          if PolyVisible then begin

             PrepareSpans_SLOW;

             if PolyVisible then begin

                {CorrectTexture_SLOW;}
                CorrectTexture_FAST(Texture^,64,16,0);
                                         {    ^  ^ ^                                  }
                                         {    |  |  \                                 }
                                         {    |   \  poziom-MIP ( 0..2 )              }
                                         {    |    maxymalny krok interpolacji        }
             end;                        {    rozmiar textury 2,4,8,16,32,64,128...   }

          end;

          end;

{/-- Tools --/}

Procedure MakePoly4(x1,y1,z1,x2,y2,z2,x3,y3,z3,x4,y4,z4:single;Var P:TPoly4);
begin
          P.VertCnt:=4;

          P.V[1].x:=x1;
          P.V[2].x:=x2;
          P.V[3].x:=x3;
          P.V[4].x:=x4;

          P.V[1].y:=y1;
          P.V[2].y:=y2;
          P.V[3].y:=y3;
          P.V[4].y:=y4;

          P.V[1].z:=z1;
          P.V[2].z:=z2;
          P.V[3].z:=z3;
          P.V[4].z:=z4;

          P.S.x:=(P.V[2].x-P.V[1].x);
          P.S.y:=(P.V[2].y-P.V[1].y);
          P.S.z:=(P.V[2].z-P.V[1].z);
          Normalize(P.S);                    {<-- wektor textury-horyzontalny }

          P.T.x:=(P.V[4].x-P.V[1].x);
          P.T.y:=(P.V[4].y-P.V[1].y);
          P.T.z:=(P.V[4].z-P.V[1].z);        {<-- wektor textury-vertykalny }
          Normalize(P.T);
          end;

{/-- Grafika:320x200x256 --/}
Procedure SetVGA256Mode;assembler;
          asm
          push ds
          mov ax,00h
          mov al,13h
          int 10h
          pop ds
          end;

{/-- Tryb textowy --/}
Procedure SetTextMode;assembler;
          asm
          push ds
          mov ax,00h
          mov al,03h
          int 10h
          pop ds
          end;

{/-- Szybkie czyszczenie --/}
Procedure ClsDWord256(Var Buf;Size:word);assembler;
          asm
          cld
          les di,dword ptr [Buf]
          mov cx,[Size]
          shr cx,2
          db $66; xor ax,ax
          db $66; rep stosw
          end;

{/-- Zaladowanie przykladowej textury --/}
Procedure LoadTexture;
Var y:word;
begin

          { Bufor pomocniczy }
          GetMem(p,320*200);

          { Zaladuj texture }
          FastLoadPCX320x200('test.pcx',p^,Pal,Width,Height);

          { Konwersja textury z 320x200 do 256x64 }
          { "Szerokosc" bufora wynosi 256 pixli   }

          { Bufor na texture }
          GetMem(Texture,256*64);

          For y:=0 to 63 do
              Move(Mem[Seg(p^):Ofs(p^)+(y*320)],Mem[Seg(Texture^):Ofs(Texture^)+(y*256)],256);

          { Zwolnij bufor pomocniczy }
          GetMem(p,320*200);

          _textwidth:=64;
          _textheight:=64;
          end;
begin


{ Ladowanie textury }
LoadTexture;

{ Male info }

ClrScr;
Writeln(' "Texturowanie perspektywiczne" made by Dreddi ');
Writeln('-----------------------------------------------');
Writeln;
Writeln(' Uzyj klawiszy kursorow oraz PageUp i PageDown do przesuwania polygona...');

Key:=ReadKey;

{ Grafika }
SetVGA256Mode;

{ Ustaw palete wczytana z obrazkiem .PCX }
SetAllPalette(Pal);

{ Obserwator }
xo:=0;
yo:=0;
zo:=0;
Ax:=0;
Ay:=0;

{ Przykladowe polygony }
{
MakePoly4(
          -50,     -50,      150,
           50,     -50,      150,
           50,      50,      150,
          -50,      50,      150,
          TestPoly
          );
}

MakePoly4(
          -50,     -50,      150,
           0,      -50,      250,
           0,       50,      250,
          -50,      50,      150,
          TestPoly
          );

{
MakePoly4(
          -50,     -50,      150,
           0,      -50,      250,
           -20,     50,      250,
          -70,      50,      150,
          TestPoly
          );
}
{
MakePoly4(
          -50,      50,      250,
           50,       50,      250,
           50,       50,      150,
          -50,      50,      150,
          TestPoly
          );
}

{ Start }

ClsDWord256(Mem[$a000:0],320*200);
ShowPoly(TestPoly);

Repeat
  key:=ReadKey;
  Case Key of
       #75:begin
           xo:=xo-5;
           ClsDWord256(Mem[$a000:0],320*200);
           ShowPoly(TestPoly);
       end;
       #77:begin
           xo:=xo+5;
           ClsDWord256(Mem[$a000:0],320*200);
           ShowPoly(TestPoly);
       end;
       #72:begin
           yo:=yo-5;
           ClsDWord256(Mem[$a000:0],320*200);
           ShowPoly(TestPoly);
       end;
       #80:begin
           yo:=yo+5;
           ClsDWord256(Mem[$a000:0],320*200);
           ShowPoly(TestPoly);
       end;
       #73:begin
           zo:=zo-5;
           ClsDWord256(Mem[$a000:0],320*200);
           ShowPoly(TestPoly);
       end;
       #81:begin
           zo:=zo+5;
           ClsDWord256(Mem[$a000:0],320*200);
           ShowPoly(TestPoly);
       end;
  end;

Until Key=#27;

{ Koniec :((( }

SetTextMode;
FreeMem(Texture,256*64);

end.



